<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Cloud Services</title>
    <meta name="description" content="Slides for the Course Big Data Tools for Advanced Professionals presentation about Cloud Services">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_5.1.0.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Assistant:wght@200..800&family=Fira+Code:wght@300..700&family=Nunito:ital,wght@0,200..1000;1,200..1000&display=swap">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">

        <section data-state="blue_overlay yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background="./files/love-1672154_1920.jpg" style="height=100vh; width100vw; margin-top: 0;">
          <!-- https://pixabay.com/users/ollis_picture-3313651 under CC0 -->
          <img style="position: absolute; top: 0px; left: 50%; transform: translate(-100%, 0%); height:5vh;" data-src="./files/logo.png">
          <img style="position: absolute; top: 0px; left: 50%; transform: translate(+100%, 0%); height:5vh; background: white; opacity: 0.7; border-radius: 4px; padding: 5px;" data-src="./files/cbs-brand.svg"-->
          <img style="position: absolute; top: 0px; left: 50%; transform: translate(+100%, 0%); height:5vh; padding: 5px;" data-src="./files/cbs-brand.svg"-->
          <h2><br><br>Cloud Services for Data Science</h2>
          <h5><br><a href="mailto:bo.mussmann@cbs.nl">Bjoern Ole Mussmann</a><br>The Netherlands eScience Center</h5>
        </section>

        <section data-state="standard 5" data-background="./files/checklist-2589418_1920.jpg" style="height=100vh; width100vw;">
          <!--
            Image by <a href="https://pixabay.com/users/StockSnap-894430/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2589418">StockSnap</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2589418">Pixabay</a>
          -->
          <h2>Table of Contents</h2>
          <ul>
            <li><a href="#/fragmentation">Service fragmentation</a></li>
            <li><a href="#/recap">?aas recap</a></li>
            <li><a href="#/vm">Infrastructure: VM on Azure</a></li>
            <li><a href="#/paas">Platform: Jupyter notebooks</a></li>
            <li><a href="#/caas">Container: webserver</a></li>
            <li><a href="#/faas">Functions: REST addition</a></li>
            <li><a href="#/summary">Summary</a></li>
          </ul>
        </section>

        <section>
          <section id="fragmentation" data-state="black_overlay 7 yellow_flag logo" data-background="./files/background-2072830_1920.jpg" style="height=100vh; width100vw;">
            <!--
              Image by <a href="https://pixabay.com/users/MIH83-464187/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2072830">Maret Hosemann</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2072830">Pixabay</a>
            -->
            <h2>Service Fragmentation</h2>
          </section>

          <section data-state="black_overlay 7 yellow_flag logo" data-background="./files/architecture-3119812_1920_crop.jpg" style="height=100vh; width100vw;">
            <!--
              Image by <a href="https://pixabay.com/users/jplenio-7645255/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=3119812">Johannes Plenio</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=3119812">Pixabay</a>
            -->
            <h2>Monolith</h2>
            <br>
            <div style="width: 60%; float: left;">
              <ul>
                <li>Complex development, maintenance</li>
                <li>Simple Operation</li>
                <li>Everybody knows how to do it</li>
                <li>Legacy way of developing software</li>
                <li>Grows more complex over time</li>
              </ul>
            </div>
            <div style="width: 30%; float: right;">
              <img data-src="./files/monolith.svg">
            </div>
          </section>

          <section data-state="black_overlay 7 yellow_flag logo" data-background="./files/rotterdam-3608980_1920.jpg" style="height=100vh; width100vw;">
            <!--
              Image by <a href="https://pixabay.com/users/ddzphoto-5605533/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=3608980">ddzphoto</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=3608980">Pixabay</a>
            -->
            <h2>Microservices</h2>
            <br>
            <div style="width: 60%; float: left;">
              <ul>
                <li>Simpler Development, maintenance</li>
                <li>Modular connected blocks</li>
                <li>Overhead through "wiring"</li>
                <li>New architecture, new skills</li>
                <li>Example: containers</li>
              </ul>
            </div>
            <div style="width: 30%; float: right;">
              <img data-src="./files/microservices.svg">
            </div>
          </section>

          <section data-state="black_overlay 7 yellow_flag logo" data-background="./files/14189024910_de4d65f366_k.jpg" style="height=100vh; width100vw;">
            <!--
              https://www.flickr.com/photos/tobin/14189024910/in/photolist-nBQsLw-HkjgX-75vsTZ-hVsWiY-23hrpii-iuVRk-7y4DaY-5rDKtM-f4D5Q6-23ePGVs-21VgdVT-23hro6Z-29QWDL-DCDHoT-23hrrbg-7xQSao-XNzX2-wQ5SZz-8FvoiU-m4PJuG-5prXZc-29iuzNE-qKUHRj-29vocmW-frzPbZ-m4PTP4-pbEFXm-dSWYgy-LHpXT-LHq64-dR6Lg-9pdBQ7-7i2htT-844TfA-dS3Qj-LHqkp-844TmJ-8aTqwa-agsG93-m4PMUs-6Ac9de-7t1abi-cJxcbw-m4R6Pd-frQ7Bf-a9NtAo-7aQABF-TqKAue-GWsGZh-rr56qg
            -->
            <h2>Functions</h2>
            <br>
            <div style="width: 57%; float: left;">
              <ul>
                <li>Simple Development, maintenance</li>
                <li>Finer granularity</li>
                <li>More overhead through APIs, etc.</li>
                <li>New architecture, new skills</li>
                <li>Dependent on FaaS platform</li>
                <ul>
                  <li>Vendor lock-in!</li>
                </ul>
              </ul>
            </div>
            <div style="width: 30%; float: right;">
              <img data-src="./files/functions_2.svg">
            </div>
            <br>
            <div style="width: 100%; float: left;">
              <font size="1">Picture: <a href="https://www.flickr.com/photos/tobin/14189024910">https://www.flickr.com/photos/tobin/14189024910</a> under <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC BY-SA 2.0</a></font>
            </div>
          </section>

          <section data-state="black_overlay 7 yellow_flag logo" data-background="./files/background-2072830_1920.jpg" style="height=100vh; width100vw;">
            <h2>Comparison</h2>
            <div style="width: 33%; float: left;">
              <h4>Monolith</h4>
              <img style="width: 80%;" data-src="./files/monolith.svg">
            </div>
            <div style="width: 33%; float: left;">
              <h4>Microservices</h4>
              <img style="width: 80%;"  data-src="./files/microservices.svg">
            </div>
            <div style="width: 33%; float: left;">
              <h4>Functions</h4>
              <img style="width: 80%;"  data-src="./files/functions_2.svg">
            </div>
            <div style="float: left; width: 100%;">
              <!--div style="background-color: white; width: fit-content; margin: auto; padding: 0 1ex; border-radius: 1ex;">
                <span style="color: #3465a4"><b>code</b></span> <span style="color: #d0cfec"><b>wiring</b></span> <span style="color: #96897b"><b>cloud</b></span>
                </div-->
                <div style="width: fit-content; margin: auto;">
                  <span style="background-color: #3465a4; padding: .1ex .5ex .1ex 1ex; border-radius: 1ex .1ex .1ex 1ex;"><b>code</b></span><span style="background-color: #d0cfec; color: #555; padding: .1ex .5ex .1ex .5ex;"><b>wiring</b></span><span style="background-color: #96897b; padding: .1ex 1ex .1ex .5ex; border-radius: 0 1ex 1ex 0;"><b>cloud</b></span>
                </div>
      </div>
          </section>
        </section>

        <section id="recap" data-state="black_overlay 6 yellow_flag logo" data-background="./files/pocket-2324160_1920.jpg" style="height=100vh; width100vw;">
          <!--
            Bild von <a href="https://pixabay.com/de/users/congerdesign-509903/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2324160">congerdesign</a> auf <a href="https://pixabay.com/de/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2324160">Pixabay</a>
          -->
          <h2>Recap ?aas</h2>
          A closer look at
          <br>
          <ul>
            <li>🖥️  Infrastructure as a Service - Rent-a-VM</li>
            <li>📦 Container as a Service - Container platform</li>
            <li>🚉 Platform as a Service - Ready-to-use tools</li>
            <li>📈 Functions as a Service - Functions in the Cloud</li>
        </section>

        <section style="height=100vh; width100vw;">
          <!--
            Image by <a href="https://pixabay.com/users/bsdrouin-5016447/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2402637">Bethany Drouin</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=2402637">Pixabay</a>
          -->
          <section data-state="black_overlay 5 yellow_flag logo" data-background="./files/network-2402637_1280.jpg" id="vm" style="height=100vh; width100vw;">
            <h2>IaaS: Azure</h2>
            <p>
            <a href="https://portal.azure.com/">https://portal.azure.com/</a>
            </p>
            <ul style="font-size: smaller;">
              <li>Virtual machines, Create, Azure virtual machine</li>
              <li>
                <table>
                  <tr>
                    <td>Resource group</td>
                    <td>Create new, my_resource_group</td>
                  </tr>
                  <tr>
                    <td>Virtual machine name</td>
                    <td>UbuntuOnAzure</li>
                  </tr>
                  <tr>
                    <td>Size</td>
                    <td>See all sizes, Standard_B1ls, Select</li>
                  </tr>
                  <tr>
                    <td>Authentication type</td>
                    <td>SSH public key</li>
                  </tr>
                </table>
              </li>
              <li>Review + create, Create</li>
              <li>Download private key and create resource</li>
              <li>Wait 2 mins, Go to resource</li>
            </ul>
          </section>

          <section data-state="black_overlay 5 yellow_flag logo" data-background="./files/network-2402637_1280.jpg" style="height=100vh; width100vw;">
            <h2>Access Server</h2>
            <div style="width: 59%; float: left;">
              <b>Local machine</b>
              <pre style="margin-top: 0;"><code class="language-bash" data-trim data-noescape style="font-size: small; padding: 1em 2em;">
                  cd Downloads
                  chmod 400 key_name.pem
                  ssh -i "key_name.pem" azureuser@[server-address]</code></pre>
            </div>
            <div style="width: 39%; float: right;">
              <b>Remote server</b>
              <pre style="margin-top: 0;"><code class="language-bash" data-trim data-noescape style="font-size: small; padding: 1em 2em;">
                  df -h && free -h
                  lscpu
                  sudo shutdown -h now</code></pre>
            </div>
            <div>
              <a href="https://maker.pro/linux/tutorial/basic-linux-commands-for-beginners">Terminal tutorial</a>
            </div>
          </section>

          <section data-state="black_overlay 5 yellow_flag logo" data-background="./files/network-2402637_1280.jpg" style="height=100vh; width100vw;">
            <h2>Server Types (Azure)</h2>
            <ul>
              <li>From <b>B1ls</b> ...</li>
              <ul>
                <li>1 CPU core, 500 MiB RAM</li>
              </ul>
              <li>... to <b>M416ms_v2</b></li>
              <ul>
                <li>416 CPU cores, 11.4 TiB RAM</li>
              </ul>
              <li>Storage optimized (16.0 TiB) <b>M128</b></li>
              <li>Accelerated computing</li>
              <ul>
                <li>GPU (Nvidia V100) <b>NC6s v3</b></li>
                <li>Tensor Cores (Nvidia T4) <b>NC4as T4 v3</b></li>
                <li>FPGA (Xilinx U250) <b>NP40s</b></li>
              </ul>
            </ul>
          </section>

          <section data-state="black_overlay 5 yellow_flag logo" data-background="./files/network-2402637_1280.jpg" style="height=100vh; width100vw;">
            <h2>Server Types (AWS)</h2>
            <ul>
              <li>From <b>t2.nano</b> ...</li>
              <ul>
                <li>1 CPU core, 500 MiB RAM</li>
              </ul>
              <li>... to <b>hpc7a.96xlarge</b></li>
              <ul>
                <li>192 CPU cores, 768 GiB RAM</li>
              </ul>
              <li>Storage optimized (336 TiB) <b>d3en.12xlarge</b></li>
              <li>Accelerated computing</li>
              <ul>
                <li>GPU (Nvidia H100) <b>m7gd.16xlarge</b></li>
                <li>Tensor Cores (Nvidia T4) <b>g4dn.x</b></li>
                <li>Machine Learning Chips (AWS Graviton 2) <b>t4g.2xlarge</b></li>
              </ul>
              <li>FPGA (Xilinx VU9P) <b>f1.2xlarge</b></li>
              <li>Media encoding accelerators (Xilinx U30) <b>vt1.3xlarge</b></li>
            </ul>
          </section>

        </section>

        <section style="height=100vh; width100vw;">
          <!--
            Image by <a href="https://pixabay.com/users/8385-8385/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=912219">Reimund Bertrams</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=912219">Pixabay</a>
          -->
          <section id="paas" data-state="black_overlay 5 yellow_flag logo" data-background="./files/cave-912219_1920.jpg"  style="height=100vh; width100vw;">
            <h2>PaaS: Jupyter Notebooks</h2>
            <ul>
              <li class="fragment highlight-current-red">Notebooks are exploratory!</li>
              <span class="fragment">
              <li>REPL: Read-Eval-Print-Loop</li>
              <li>Can run different kernels (C, Scala, Python, R)</li>
              <li>Challenges:</li>
              <ul>
                <li>Testing</li>
                <li>Hidden states</li>
                <li>Versioning (git etc.)</li>
                <li>Bad habits: Untitled25.ipynb</li>
                <li>Possible non-linear workflow</li>
                <li><a href="https://docs.google.com/presentation/d/1n2RlMdmv1p25Xy5thJUhkKGvjtV-dkAIsUXP-AL4ffI/preview">I don't like notebooks (@joelgrus)</a>
              </ul>
              </span>
            </ul>
          </section>

          <section data-state="black_overlay 5 yellow_flag logo" data-background="./files/cave-912219_1920.jpg" style="height=100vh; width100vw;">
            <h2>Colab Notebook</h2>
            <p>
              <a href="https://colab.research.google.com">https://colab.research.google.com</a>
            </p>
            <ul>
              <li>Login ➡️ Examples ➡️ Overview of Colaboratory Features</li>
              <li>Explore!</li>
              <span class="fragment">
                <li>More tutorials:</li>
                <ul>
                  <li>File ➡️ Open Notebook ➡️ Examples</li>
                  <li>Markdown Guide, Charts, etc.</li>
                </ul>
              </ul>
            </ul>
          </section>

        </section>

        <section style="height=100vh; width100vw;">

          <section data-state="standard 7" data-background="./files/business-1845350_1920.jpg" style="margin-top: 0;" id="caas">
            <h2>CAAS</h2>
            <h4>Containers...?</h4>
          </section>

          <section data-state="standard" data-background="./files/business-1845350_1920.jpg"  style="margin-top: 0;">
          <!--Image by <a href="https://pixabay.com/users/Pexels-2286921/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1845350">Pexels</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1845350">Pixabay</a>-->
          <h3>Docker vs. Virtual Machines</h3>
          <img style="object-fit: contain;" data-src="./files/docker-containerized-and-vm-transparent-bg.png"></img>
          <p style="margin: 0; padding: 0; font-size: x-small;">
            <a href="https://www.docker.com/resources/what-container" style="color: black;">https://www.docker.com/resources/what-container</a>
          </p>
        </section>

        <section data-state="standard" data-background="./files/business-1845350_1920.jpg" data-background-color="rgb(150, 150, 150)" style="margin-top: 0;">
          <!--Image by <a href="https://pixabay.com/users/Pexels-2286921/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1845350">Pexels</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1845350">Pixabay</a>-->
          <h3>Docker host</h3>
          <img style="object-fit: contain; height: 30vh;" data-src="./files/docker-kernel.png"></img>
          <p style="margin: 0; padding: 0; font-size: x-small;">
            <a href="https://www.docker.com/blog/docker-101-introduction-docker-webinar-recap/" style="color: black;">https://www.docker.com/blog/docker-101-introduction-docker-webinar-recap/</a>
          </p>
        </section>

        <section data-state="standard" data-background="./files/business-1845350_1920.jpg" data-background-color="rgb(150, 150, 150)" style="margin-top: 0;">
          <!--Image by <a href="https://pixabay.com/users/Pexels-2286921/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1845350">Pexels</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1845350">Pixabay</a>-->
          <h3>Dockerfile ➡️ Image ➡️ Container</h3>
          <div style="max-width: 90vw; margin: auto;">
            <p style="width: 100%; text-align: left; margin-bottom: 0;">
              Dockerfile (and other content)
            </p>
            <div style="width: 100%;overflow: auto;">
              <pre style="width: 45%; float: left; margin: auto;"><code class="docker" data-noescape style="padding: 1em 1.5em; margin: 0;">$ cat Dockerfile
FROM ubuntu:latest
COPY script.sh /
CMD bash /script.sh</code></pre>
              <pre style="width: 45%; float: right; margin: auto;"><code class="bash" data-noescape style="padding: 1em 1.5em; margin: 0;">$ cat script.sh
echo "Hi from Docker!"


</code></pre>
            </div>
            <p style="width: 100%; text-align: left; margin-bottom: 0;">
              Build image
            </p>
            <div style="width: 100%;overflow: auto;">
              <pre style="padding-top: 1ex; width: 100%; margin: auto;"><code class="bash" data-trim data-noescape style="padding: 1em 1.5em; margin: 0;">
                $ docker build -t my_demo_app .
              </code></pre>
            </div>
            <p style="width: 100%; text-align: left; margin-bottom: 0;">
              Create container
            </p>
            <pre style="padding-top: 1ex; width: 100%; margin: auto;"><code class="bash" data-trim data-noescape style="padding: 1em 1.5em; margin: 0;">
              $ docker run --rm my_demo_app
              Hi from Docker!
            </code></pre>
          </div>
        </section>

        <section data-state="black_overlay 5 logo yellow_flag" data-background="./files/container-1638068_1920_crop.jpg">
          <h3>What's the benefit?</h3>
          <ul>
            <div id="old_line" class="fragment">
              <li>"BuT iT rUnS oN mY LAptoP..."<br>
                <span class="fragment">"Back up your email, your laptop goes in production!"</span></li>
            <ul>
            </ul>
            </div>
            <div id="new_line" class="fragment">
            </div>
            <li class="fragment">Online or offline registry (Hub), vast ecosystem</li>
            <li class="fragment">Encapsulated environments, no dependency hell</li>
            <li class="fragment">Fast, consistent DevOps</li>
          </ul>
        </section>

          <section data-state="black_overlay 5 logo yellow_flag" data-background="./files/container-1638068_1920_crop.jpg">
            <h2>Caas: Create Locally, Run Anywhere</h2>
              <ul>
                <li>Deploy on AWS, Azure, Google Cloud, etc.</li>
                <li>Run environments on <a href="https://mybinder.org">mybinder.org</a></li>
                <li>Clusters, resilience possible: Kubernetes, Rancher, Openshift Container Platform, Nomad</li>
              </ul>
          </section>
        </section>

        <section>
          <section id="faas" data-state="black_overlay logo yellow_flag" data-background="./files/geometry-1044090_1920.jpg" style="height=100vh; width100vw;">
            <!--
              Image by <a href="https://pixabay.com/users/geralt-9301/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1044090">Gerd Altmann</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1044090">Pixabay</a>
            -->
            <h2 style="text-transform: none;">FAAS: AWS λ</h2>
          </section>

          <section data-state="black_overlay logo yellow_flag 7" data-background="./files/network-cable-2245837_1920.jpg" style="height=100vh; width100vw;">
            <h2>Serverless Computing</h2>
            <p>Where does the cable go?</p>
            <span class="fragment">
              <ul>
                <li>Server hidden behind abstraction layers</li>
                <li>Dynamically allocated resources</li>
                <li>Pricing per resources consumed</li>
              </ul>
              <br>
              <br>
              <span style="font-size: small;">Sources: <a href="https://arxiv.org/pdf/1812.03651.pdf">Hellerstein et al. "Serverless Computing: One Step Forward, Two Steps Back"</a>, <a href="https://techcrunch.com/2015/11/24/aws-lamda-makes-serverless-applications-a-reality/">Techcrunch "AWS Lambda Makes Serverless Applications A Reality"</a>
              </span>
            </span>
          </section>

          <section data-state="black_overlay logo yellow_flag 7" data-background="./files/3-gordon-freeman-half-life-551557.jpg" style="height=100vh; width100vw;">
            <h2><span style="text-transform: lowercase;">λ</span>: Discussion</h2>
            <div style="width: 50%; float: left;">
              <h3>Drawbacks</h3>
              <ul>
                <li>limited languages</li>
                <li>vendor lock-in</li>
                <li>new concept</li>
                <li>performance</li>
                <li>no GPUs, etc.</li>
                <li>debugging</li>
              </ul>
            </div>
            <div style="width: 50%; float: right;">
              <h3>Benefits</h3>
              <ul>
                <li>Productivity</li>
                <li>Elasticity</li>
                <li>Cost</li>
              </ul>
            </div>
          </section>

          <section data-state="black_overlay 5 logo yellow_flag" data-background="./files/meditation-2214532_1280.jpg" style="height=100vh; width100vw;" data-auto-animate>
            <h2 style="text-transform: none;">RESTful APIs</h2>
            <p>
              <b>RE</b>presentational <b>S</b>tate <b>T</b>ransfer for Web Services
            </p>
            <ul>
              <li>Base URL: <a href="http://api.example.com/customers/">http://api.example.com/customers/</a></li>
            </ul>
            <pre data-id="code"><code class="language-bash" data-trim data-noescape data-line-numbers style="padding: 1em 1.5em;">
                curl "http://api.example.com/customers"
            </code></pre>
          </section>
          <section data-state="black_overlay 5 logo yellow_flag" data-background="./files/meditation-2214532_1280.jpg" style="height=100vh; width100vw;" data-auto-animate>
            <h2 style="text-transform: none;">RESTful APIs</h2>
            <p>
              <b>RE</b>presentational <b>S</b>tate <b>T</b>ransfer for Web Services
            </p>
            <ul>
              <li>Base URL: <a href="http://api.example.com/customers/">http://api.example.com/customers/</a></li>
              <li>HTTP methods e.g. GET, POST, PUT, PATCH, DELETE</li>
            </ul>
            <pre data-id="code"><code class="language-bash" data-trim data-noescape data-line-numbers="2-3" style="padding: 1em 1.5em;">
                curl "http://api.example.com/customers"
                curl --request GET "http://api.example.com/customers"
                curl --request POST "http://api.example.com/customers/123/order"
            </code></pre>
          </section>
          <section data-state="black_overlay 5 logo yellow_flag" data-background="./files/meditation-2214532_1280.jpg" style="height=100vh; width100vw;" data-auto-animate>
            <h2 style="text-transform: none;">RESTful APIs</h2>
            <p>
              <b>RE</b>presentational <b>S</b>tate <b>T</b>ransfer for Web Services
            </p>
            <ul>
              <li>Base URL: <a href="http://api.example.com/customers/">http://api.example.com/customers/</a></li>
              <li>HTTP methods e.g. GET, POST, PUT, PATCH, DELETE</li>
              <li>(Media Type, Content)</li>
            </ul>
            <pre data-id="code"><code class="language-bash" data-trim data-noescape data-line-numbers="3-5" style="padding: 1em 1.5em;">
                curl "http://api.example.com/customers"
                curl --request GET "http://api.example.com/customers"
                curl --request POST "http://api.example.com/customers/123/order" \
                  --header "content-type: application/json" \
                  --data '{"order": "pizza"}'
            </code></pre>
            <span style="font-size: small;">Source: Richardson, Leonard; Amundsen, Mike (2013), <a href="http://www.restfulwebapis.org/">RESTful Web APIs</a>, O'Reilly Media, ISBN 978-1-449-35806-8</span>
          </section>

          <section data-state="black_overlay logo yellow_flag" data-background="./files/geometry-1044090_1920.jpg" style="height=100vh; width100vw;">
            <!--
              Image by <a href="https://pixabay.com/users/geralt-9301/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1044090">Gerd Altmann</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1044090">Pixabay</a>
            -->
            <h2 style="text-transform: none;">FAAS: AWS Lambda</h2>
            <a href="https://console.aws.amazon.com/lambda/">https://console.aws.amazon.com/lambda/</a>
            <ul>
              <li>Create Function, Function name: add_stuff</li>
              <li>Runtime: Python 3.12</li>
              <li>Create Function, Paste Code, Deploy</li>
            </ul>
            <pre style="padding-top: 1ex; width: 100%; margin: auto;"><code class="language-python" data-trim data-noescape style="padding: 1em 1.5em; margin: 0;">
              import json

              def lambda_handler(event, context):
                  first_number = event["queryStringParameters"]["first_number"]
                  second_number = event["queryStringParameters"]["second_number"]
                  added = int(first_number) + int(second_number)
                  
                  return {'statusCode': 200,
                          'body': json.dumps('Result: ' + str(added))}
            </code></pre>
          </section>

          <section data-state="black_overlay logo yellow_flag" data-background="./files/geometry-1044090_1920.jpg" style="height=100vh; width100vw;">
            <!--
              Image by <a href="https://pixabay.com/users/geralt-9301/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1044090">Gerd Altmann</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1044090">Pixabay</a>
            -->
            <h2 style="text-transform: none;">REST API</h2>
            <ul>
              <li>Add trigger, API Gateway</li>
              <li>Create a new API, REST API</li>
              <li>Security: Open (only for demo!)</li>
              <li>Add</li>
              <li>Copy API endpoint URL</li>
              <li>Run curl in a terminal</li>
              <ul>
                <li>... or paste the assembled URL in a browser</li>
              </ul>
            </ul>
            <pre style="padding-top: 1ex; width: 90%; margin: auto;"><code class="bash" data-trim data-noescape style="padding: 1em 1.5em; margin: 0;">
              curl '[API endpoint URL]?first_number=7&second_number=8'
            </code></pre>
          </section>
        </section>

        <section id="summary" data-state="black_overlay 3 logo yellow_flag" data-background="./files/note-pad-1215425_1920.jpg" style="height=100vh; width100vw;">
          <!--
            Image by <a href="https://pixabay.com/users/1681551-1681551/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1215425">Robert Armstrong</a> from <a href="https://pixabay.com/?utm_source=link-attribution&amp;utm_medium=referral&amp;utm_campaign=image&amp;utm_content=1215425">Pixabay</a>
          -->
          <div style="transform: rotate(-5deg); width: 82%; float: left; font-size: 90%;">
          <h2 style="color: black;">Summary</h2>
          <ul style="color: black;">
            <li>Service fragmentation</li>
            <ul>
              <li>Monolith, microservices, λ-functions</li>
            </ul>
            <li>Jupyter notebooks</li>
            <li>Docker</li>
            <li>Demos:</li>
            <ul>
              <li>Infrastructure as a Service: Azure</li>
              <li>Platform as a Service: Jupyter notebooks</li>
              <li>Containers as a Service: MyBinder</li>
              <li>Functions as a Service: AWS</li>
            </ul>
          </div>
        </section>

        <section data-state="black_overlay 3 logo yellow_flag" data-background="./files/question-mark-2492009_1920.jpg" style="height=100vh; width100vw;">
        </section>

      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/theme/escience_5.1.0.js"></script>
    <script src="cloud_services.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
